<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Paramplaneja extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "paramplaneja";
    protected $environment;

    public function __construct($crudService, $parameterBag, $environment) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment = $environment;
        parent::__construct($crudService, $parameterBag);
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $cdfilial = $this->getColumnValue($request->getFilterCriteria()->getConditions(), "CDFILIAL");
        if (!isset($cdfilial)) {
        	$cdfilial = $this->environment->getCdFilial();
        }
        $nrorg = $this->environment->getNrOrgTrab();
        $newrequest = $this->buildNewRequest($request, $cdfilial, $nrorg);
        parent::find($newrequest, $response);
    }

    public function getColumnValue($conditions, $columnName) {
    	foreach ($conditions as $condition) {
    		if (strtoupper($condition["columnName"]) == $columnName) {
    			return $condition["value"];
    		}
    	}
    }

    public function buildNewRequest($request, $cdfilial, $nrorg) {
        $conditions[] = array("columnName" => "CDFILIAL", "value" => $cdfilial, "operator" => "=");
    	$conditions[] = array("columnName" => "NRORG", "value" => $nrorg, "operator" => "=");
        $newrequest = new DTO\Request\Filter(
            new FilterCriteria($this->dataSourceName, $conditions, $request->getFilterCriteria()->getPage(), $request->getFilterCriteria()->getPageSize()),
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
    	return $newrequest;	
    }
}
